import math
import numpy as np
import scipy.linalg as nla
import matplotlib.pyplot as plt
from scipy.stats import ortho_group

abscissas = []
ordinates = []
m = 10
for exponent in range(5,15) :
    U = ortho_group.rvs(m)
    V = ortho_group.rvs(m)
    kappa = 10**exponent
    T = np.diag ([kappa**(-i/(m-1)) for i in range(m)])
    A = np.dot (U, np.dot (T, V))
    est_kappa = np.linalg.cond(A)
    x = np.random.rand(m)
    b = np.dot (A,x)
    xback = nla.solve (A,b)
    errrel = np.linalg.norm(x-xback)/np.linalg.norm(x)
    abscissas.append(exponent)
    ordinates.append(- math.log(errrel)/math.log(10))

a = np.polyfit(abscissas, ordinates, 1)
def f(x) :
    return a[0]*x+a[1]

plt.figure ()
plt.axes ()
plt.plot (abscissas, ordinates)
x = np.linspace(abscissas[0], abscissas[-1], 20)
plt.plot (x, f(x))
plt.show ()

