import numpy as np
import scipy.linalg as nla

# Extrait d'une doc. Python:
# The common overwrite_<> option in many routines, allows the input arrays 
# to be overwritten to avoid extra memory allocation. However this requires 
# the array to satisfy two conditions which are memory order and the data 
# type to match exactly the order and the type expected by the routine.

# Je demande donc 
# - des flottants 64 bits = double précision
# - que les matrices soient rangées en mémoire colonne par colonne
#   (l'ordre du langage FORTRAN).

A = np.array([[-3,4,1],[2,1,-3],[1,-2,1]], dtype=np.float64, order='F')

# Pour faire simple, on fait en sorte qu'il n'y ait pas d'échange de lignes.

nla.lu_factor(A, overwrite_a=True)
print ("A =")
print (A)

B = np.array([[1,0,0],[0,1,0],[0,0,1]],dtype=np.float64, order='F')
print ("B =")
print (B)

for i in [0,1,2] :
    # v = l'adresse de la ième colonne de B
    v = B[:,i]
    # Résolution 
    nla.solve_triangular(A, v, lower=True, unit_diagonal=True, overwrite_b=True)
    nla.solve_triangular(A, v, lower=False, unit_diagonal=False, overwrite_b=True)

print ("A^(-1) =")
print (B)

A = np.array([[-3,4,1],[2,1,-3],[1,-2,1]], dtype=np.float64, order='F')
I = np.dot (A, B)
print ("I =")
print (I)

